#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2006 Damon P. Little

#-----------------------OPENING INFO
print "a script for making all possible motif combinations from ACGT\n";
print "USAGE: patterns.pl motif_size table\n";



#-----------------------STANDARD DB INFO
use DBI;
my $db = 'barcode';
my $host = 'localhost';
my $id = 'barcode';
my $pwd = 'barcode';
$table = $ARGV[1];



#-----------------------MAKE MOTIFS
$motif = $ARGV[0];
if(($motif) && ($motif < 11)){
	#change if one wants to use things other than DNA
	$bases = "ACGT";

	@letters = split("", $bases);
	$buffer = "";
	foreach $one (@letters){
		if($motif > 1){
			foreach $two (@letters){
				if($motif > 2){
					foreach $three (@letters){
						if($motif > 3){
							foreach $four (@letters){
								if($motif > 4){
									foreach $five (@letters){
										if($motif > 5){
											foreach $six (@letters){
												if($motif > 6){
													foreach $seven (@letters){
														if($motif > 7){
															foreach $eight (@letters){
																if($motif > 8){
																	foreach $nine (@letters){
																		if($motif > 9){
																			foreach $ten (@letters){
																				$buffer .= $one . $two . $three . $four . $five . $six . $seven . $eight . $nine . $ten . " ";
																				}
																			} else {
																				$buffer .= $one . $two . $three . $four . $five . $six . $seven . $eight . $nine . " ";
																				}
																		}
																	} else {
																		$buffer .= $one . $two . $three . $four . $five . $six . $seven . $eight . " ";
																		}
																}
															} else {
																$buffer .= $one . $two . $three . $four . $five . $six . $seven . " ";
																}
														}
													} else {
														$buffer .= $one . $two . $three . $four . $five . $six . " ";
														}
												}	
											} else {
												$buffer .= $one . $two . $three . $four . $five . " ";
												}
										}
									} else {
									$buffer .= $one . $two . $three . $four . " ";
									}
								}
							} else {
								$buffer .= $one . $two . $three . " ";
								}
						}
					} else {
						$buffer .= $one . $two . " ";
						}
				}
			} else {
				$buffer .= $one . " ";
				}
		}

		
		
#-----------------------CONNECT TO DATABASE
	my $dbh = DBI->connect("DBI:mysql:$db:$host",$id,$pwd);
	if(!defined $dbh) {
		die "Can't connect: $DBI::errstr \n";
		}

		
		
#-----------------------MAKE TABLE	
	$mystr = "CREATE TABLE $table (
			motif_id int(11) NOT NULL auto_increment,
			motif char($motif) default NULL,
			PRIMARY KEY  (motif_id),
			KEY motif_index (motif)
			) TYPE=MyISAM";
	$sth = $dbh->prepare($mystr) || die "Can't prepare $statement: $dbh->errstr\n";
	$rv = $sth->execute || die "can't execute the query: $sth->errstr";
	



#-----------------------INSERT MOTIFS	
	@combos = split(" ", $buffer);
	$k = 0;
	foreach $value (@combos){
		$k++;
		$mystr = "INSERT INTO $table (motif_id, motif) VALUES (NULL, ?)";
		$sth = $dbh->prepare($mystr) || die "Can't prepare $statement: $dbh->errstr\n";
		$rv = $sth->execute ($value) || die "can't execute the query: $sth->errstr";
		}
		
		
		
#-----------------------DONE	
	$rc = $sth->finish;
	$dbh->disconnect;	
	print "$k patterns inserted into database as table $table\n";
	}
exit 0;
